Foreman - Bug #32266

wrong number of arguments (given 1, expected 2) on user-data endpoint
04/07/2021 01:44 PM - Harm Endres

Status: Closed
Priority: Low
Assignee: Lukas Zapletal
Category: Templates

Target version:

Difficulty: Fixed in Releases: 241,25.0
Triaged: Yes Found in Releases: 2.4.0
Bugzilla link: Red Hat JIRA:
Pull request: https://github.com/theforeman/foreman/p

ull/g442,

https://github.com/theforeman/foreman/p

ull/g504
Description
Hey folks,

we have an issue using the /userdata/user-data endpoint wiht Foreman 2.4.0.

2021-04-07T13:36:26 [I|appladffbed6] Backtrace for 'wrong number of arguments (given 1, expected 2
)' error (ArgumentError): wrong number of arguments (given 1, expected 2)
adffbed67d4224c6177£20c4e042879b | /home/foreman/app/controllers/concerns/foreman/controller/temp
late_rendering.rb:28:in "render_error'

adffbed67d4224c6177£20c4e042879b | /home/foreman/app/controllers/userdata_controller.rb:40:in "re
nder_userdata_template’

adffbed67d4224c6177£20c4e042879b | /home/foreman/app/controllers/userdata_controller.rb:14:in ‘us
erdata’

adffbed67d4224c6177£20c4e042879b | /home/foreman/vendor/ruby/2.7.0/gems/actionpack-6.0.3.5/1ib/ac
tion_controller/metal/basic_implicit_render.rb:6:in "send_action'

adffbed67d4224c6177£20c4e042879b | /home/foreman/vendor/ruby/2.7.0/gems/actionpack-6.0.3.5/1ib/ab
stract_controller/base.rb:195:in “process_action'

ad4ffbed67d4224c6177£20c4e042879b | /home/foreman/vendor/ruby/2.7.0/gems/actionpack-6.0.3.5/1ib/ac
tion_controller/metal/rendering.rb:30:in "process_action'

ad4ffbed67d4224c6177£20c4e0428790 | /home/foreman/vendor/ruby/2.7.0/gems/actionpack-6.0.3.5/1ib/ab
stract_controller/callbacks.rb:42:in ‘block in process_action'

adffbed67d4224c6177£20c4e042879b | /home/foreman/vendor/ruby/2.7.0/gems/activesupport-6.0.3.5/1ib
/active_support/callbacks.rb:112:in “block in run_callbacks'

adffbed67d4224c6177£20c4e042879b | /home/foreman/app/controllers/concerns/foreman/controller/time
zone.rb:10:in "~ set_timezone'

ad4ffbed67d4224c6177£20c4e042879b | /home/foreman/vendor/ruby/2.7.0/gems/activesupport-6.0.3.5/1ib
/active_support/callbacks.rb:121:in “block in run_callbacks'

adffbed67d4224c6177f20c4e042879b | /home/foreman/app/models/concerns/foreman/thread_session.rb:32
:in “clear_thread'

adffbed67d4224c6177£20c4e042879b | /home/foreman/vendor/ruby/2.7.0/gems/activesupport-6.0.3.5/1ib
/active_support/callbacks.rb:121:in “block in run_callbacks'

adffbed67d4224c6177£20c4e042879b | /home/foreman/app/controllers/concerns/foreman/controller/topb
ar_sweeper.rb:12:in "“set_topbar_sweeper_controller'

ad4ffbed67d4224c6177£20c4e042879b | /home/foreman/vendor/ruby/2.7.0/gems/activesupport-6.0.3.5/1ib
/active_support/callbacks.rb:121:in “block in run_callbacks'

adffbed67d4224c6177f20c4e042879b | /home/foreman/vendor/ruby/2.7.0/gems/audited-4.10.0/1ib/audite
d/sweeper.rb:14:in ‘around'

adffbed67d4224c6177£20c4e042879b | /home/foreman/vendor/ruby/2.7.0/gems/activesupport-6.0.3.5/1ib
/active_support/callbacks.rb:121:in “block in run_callbacks'

adffbed67d4224c6177£20c4e042879b | /home/foreman/vendor/ruby/2.7.0/gems/audited-4.10.0/1ib/audite
d/sweeper.rb:14:in "~around'

ad4ffbed67d4224c6177£20c4e042879b | /home/foreman/vendor/ruby/2.7.0/gems/activesupport-6.0.3.5/1ib
/active_support/callbacks.rb:121:in “block in run_callbacks'

adffbed67d4224c6177f20c4e042879b | /home/foreman/vendor/ruby/2.7.0/gems/activesupport-6.0.3.5/1ib
/active_support/callbacks.rb:139:in “run_callbacks'

adffbed67d4224c6177£20c4e042879b | /home/foreman/vendor/ruby/2.7.0/gems/actionpack-6.0.3.5/1ib/ab
stract_controller/callbacks.rb:41:in “process_action'

adffbed67d4224c6177£20c4e042879b | /home/foreman/vendor/ruby/2.7.0/gems/actionpack-6.0.3.5/1ib/ac
tion_controller/metal/rescue.rb:22:in ‘process_action'

adffbed67d4224c6177f20c4e042879b | /home/foreman/vendor/ruby/2.7.0/gems/actionpack-6.0.3.5/1ib/ac
tion_controller/metal/instrumentation.rb:33:in “block in process_action'
adffbed67d4224c6177£20c4e042879b | /home/foreman/vendor/ruby/2.7.0/gems/activesupport-6.0.3.5/1ib
/active_support/notifications.rb:180:in “block in instrument'

adffbed67d4224c6177£20c4e042879b | /home/foreman/vendor/ruby/2.7.0/gems/activesupport-6.0.3.5/1ib
/active_support/notifications/instrumenter.rb:24:in " instrument'

adffbed67d4224c6177£20c4e042879b | /home/foreman/vendor/ruby/2.7.0/gems/activesupport-6.0.3.5/1ib
/active_support/notifications.rb:180:in " instrument'

adffbed67d4224c6177f20c4e042879b | /home/foreman/vendor/ruby/2.7.0/gems/actionpack-6.0.3.5/1ib/ac
tion_controller/metal/instrumentation.rb:32:in “process_action'

adffbed67d4224c6177£20c4e042879b | /home/foreman/vendor/ruby/2.7.0/gems/actionpack-6.0.3.5/1ib/ac
tion_controller/metal/params_wrapper.rb:245:in “process_action'

adffbed67d4224c6177£20c4e042879b | /home/foreman/vendor/ruby/2.7.0/gems/activerecord-6.0.3.5/1ib/
active_record/railties/controller_runtime.rb:27:in “process_action'
adffbed67d4224c6177£20c4e0428790 | /home/foreman/vendor/ruby/2.7.0/gems/actionpack-6.0.3.5/1ib/ab
stract_controller/base.rb:136:in “process'

adffbed67d4224c6177f20c4e042879b | /home/foreman/vendor/ruby/2.7.0/gems/actionview-6.0.3.5/1ib/ac
tion_view/rendering.rb:39:in ‘process'

adffbed67d4224c6177£20c4e042879b | /home/foreman/vendor/ruby/2.7.0/gems/actionpack-6.0.3.5/1ib/ac
tion_controller/metal.rb:190:in “dispatch’

adffbed67d4224c6177£20c4e042879b | /home/foreman/vendor/ruby/2.7.0/gems/actionpack-6.0.3.5/1ib/ac
tion_controller/metal.rb:254:in “dispatch’

adffbed67d4224c6177£20c4e042879b | /home/foreman/vendor/ruby/2.7.0/gems/actionpack-6.0.3.5/1ib/ac
tion_dispatch/routing/route_set.rb:50:in “dispatch’

adffbed67d4224c6177f20c4e042879b | /home/foreman/vendor/ruby/2.7.0/gems/actionpack-6.0.3.5/1ib/ac
tion_dispatch/routing/route_set.rb:33:in "serve'

adffbed67d4224c6177£20c4e042879b | /home/foreman/vendor/ruby/2.7.0/gems/actionpack-6.0.3.5/1ib/ac
tion_dispatch/journey/router.rb:49:in “block in serve'

adffbed67d4224c6177£20c4e042879b | /home/foreman/vendor/ruby/2.7.0/gems/actionpack-6.0.3.5/1ib/ac
tion_dispatch/journey/router.rb:32:in “each'

adffbed67d4224c6177£20c4e042879b | /home/foreman/vendor/ruby/2.7.0/gems/actionpack-6.0.3.5/1ib/ac
tion_dispatch/journey/router.rb:32:in "serve'

adffbed67d4224c6177f20c4e042879b | /home/foreman/vendor/ruby/2.7.0/gems/actionpack-6.0.3.5/1ib/ac
tion_dispatch/routing/route_set.rb:834:in “call'

adffbed67d4224c6177£20c4e042879b | /home/foreman/vendor/ruby/2.7.0/gems/apipie-dsl-2.3.0/1ib/apip
ie_dsl/static_dispatcher.rb:67:in “call’

adffbed67d4224c6177£20c4e042879b | /home/foreman/vendor/ruby/2.7.0/gems/apipie-rails-0.5.18/1ib/a
pipie/static_dispatcher.rb:66:in “call'

adffbed67d4224c6177£20c4e0428790 | /home/foreman/vendor/ruby/2.7.0/gems/apipie-rails-0.5.18/1ib/a
pipie/extractor/recorder.rb:137:in “call'

adffbed67d4224c6177£20c4e042879b | /home/foreman/lib/foreman/middleware/telemetry.rb:10:in “call’
adffbed67d4224c6177£20c4e042879b | /home/foreman/vendor/ruby/2.7.0/gems/apipie-rails-0.5.18/1ib/a
pipie/middleware/checksum_in_headers.rb:27:in “call'

adffbed67d4224c6177£20c4e042879b | /home/foreman/lib/foreman/middleware/catch_json_parse_errors.r
b:9:in “call’

adffbed67d4224c6177£20c4e042879b | /home/foreman/vendor/ruby/2.7.0/gems/rack-2.2.3/1ib/rack/tempf
ile_reaper.rb:15:in “call’

adffbed67d4224c6177f20c4e042879> | /home/foreman/vendor/ruby/2.7.0/gems/rack-2.2.3/1ib/rack/etag.
rb:27:in “call'

adffbed67d4224c6177f20c4e042879b | /home/foreman/vendor/ruby/2.7.0/gems/rack-2.2.3/1ib/rack/condi
tional_get.rb:27:in “call'

adffbed67d4224c6177£20c4e042879b | /home/foreman/vendor/ruby/2.7.0/gems/rack-2.2.3/1ib/rack/head.
rb:12:in “call'

adffbed67d4224c6177£20c4e042879b | /home/foreman/vendor/ruby/2.7.0/gems/actionpack-6.0.3.5/1ib/ac
tion_dispatch/http/content_security_policy.rb:18:in “call'

adffbed67d4224c6177f20c4e042879 | /home/foreman/lib/foreman/middleware/logging_context_session.r
b:22:in “call'

adffbed67d4224c6177£20c4e042879b | /home/foreman/vendor/ruby/2.7.0/gems/rack-2.2.3/1ib/rack/sessi
on/abstract/id.rb:266:in "context'

adffbed67d4224c6177£20c4e042879b | /home/foreman/vendor/ruby/2.7.0/gems/rack-2.2.3/1ib/rack/sessi
on/abstract/id.rb:260:in “call'

adffbed67d4224c6177£20c4e042879b | /home/foreman/vendor/ruby/2.7.0/gems/actionpack-6.0.3.5/1ib/ac
tion_dispatch/middleware/cookies.rb:648:in “call'

adffbed67d4224c6177£20c4e042879b | /home/foreman/vendor/ruby/2.

tion_dispatch/middleware/callbacks.rb:27:in “block in call’

adffbed67d4224c6177f20c4e042879b | /home/foreman/vendor/ruby/2.

/active_support/callbacks.rb:101:in “run_callbacks'

adffbed67d4224c6177f20c4e042879b | /home/foreman/vendor/ruby/2.

tion_dispatch/middleware/callbacks.rb:26:in “call'

adffbed67d4224c6177£20c4e042879b | /home/foreman/vendor/ruby/2.

tion_dispatch/middleware/actionable_exceptions.rb:18:in “call’

adffbed67d4224c6177£20c4e042879b | /home/foreman/vendor/ruby/2.

tion_dispatch/middleware/debug_exceptions.rb:32:in “call’

adffbed67d4224c6177f20c4e042879b | /home/foreman/vendor/ruby/2.

tion_dispatch/middleware/show_exceptions.rb:33:in “call'

adffbed67d4224c6177f20c4e042879b | /home/foreman/vendor/ruby/2.

s/rack/logger.rb:37:in “call_app'

adffbed67d4224c6177£20c4e042879b | /home/foreman/vendor/ruby/2.

s/rack/logger.rb:28:in “call'

adffbed67d4224c6177£20c4e042879b | /home/foreman/vendor/ruby/2.

/sprockets/rails/quiet_assets.rb:13:in ‘call'

7.0/gems/actionpack-6.0.3.5/1ib/ac
7.0/gems/activesupport-6.0.3.5/1ib
7.0/gems/actionpack-6.0.3.5/1ib/ac
7.0/gems/actionpack-6.0.3.5/1ib/ac
7.0/gems/actionpack-6.0.3.5/1ib/ac
7.0/gems/actionpack-6.0.3.5/1ib/ac
7.0/gems/railties-6.0.3.5/1lib/rail
7.0/gems/railties-6.0.3.5/1ib/rail

7.0/gems/sprockets-rails-3.2.2/1ib

adffbed67d4224c6177f20c4e042879b | /home/foreman/lib/foreman/middleware/logging_context_request.r

b:11:in “call'

adffbed67d4224c6177f20c4e042879b | /home/foreman/vendor/ruby/2.

tion_dispatch/middleware/remote_ip.rb:81l:in “call'

adffbed67d4224c6177£20c4e042879b | /home/foreman/vendor/ruby/2.

tion_dispatch/middleware/request_id.rb:27:in ‘call'

adffbed67d4224c6177£20c4e042879b | /home/foreman/vendor/ruby/2.

d_override.rb:24:in “call'

adffbed67d4224c6177f20c4e042879b | /home/foreman/vendor/ruby/2.

me.rb:22:in “call’

adffbed67d4224c6177f20c4e042879b | /home/foreman/vendor/ruby/2.
‘call'
adffbed67d4224c6177£20c4e042879b | /home/foreman/vendor/ruby/2.

/active_support/cache/strategy/local_cache_middleware.rb:29:1in

tion_dispatch/middleware/executor.rb:14:in “call'

adffbed67d4224c6177£20c4e042879b | /home/foreman/vendor/ruby/2.

tion_dispatch/middleware/static.rb:126:in “call’

adffbed67d4224c6177f20c4e042879b | /home/foreman/vendor/ruby/2.

ile.rb:110:in “call'

adffbed67d4224c6177f20c4e042879b | /home/foreman/vendor/ruby/2.

tion_dispatch/middleware/host_authorization.rb:76:in “call'

adffbed67d4224c6177£20c4e042879b | /home/foreman/vendor/ruby/2.

secure_headers/middleware.rb:11:in “call"'

adffbed67d4224c6177£20c4e042879b | /home/foreman/vendor/ruby/2.

s/engine.rb:527:in “call'

adffbed67d4224c6177f20c4e042879b | /home/foreman/vendor/ruby/2.

s/railtie.rb:190:in “public_send'

adffbed67d4224c6177f20c4e042879b | /home/foreman/vendor/ruby/2.

s/railtie.rb:190:in ‘method_missing'

adffbed67d4224c6177£20c4e042879b | /home/foreman/vendor/ruby/2.

p.rb:74:in “block in call'

adffbed67d4224c6177£20c4e042879b | /home/foreman/vendor/ruby/2.

p.rb:58:in “each'

adffbed67d4224c6177f20c4e042879b | /home/foreman/vendor/ruby/2.

p.rb:58:in “call'

adffbed67d4224c6177f20c4e042879b | /home/foreman/vendor/ruby/2.

guration.rb:248:in “call'

adffbed67d4224c6177£20c4e042879b | /home/foreman/vendor/ruby/2.

st.rb:76:in “block in handle_request'

adffbed67d4224c6177£20c4e042879b | /home/foreman/vendor/ruby/2.

d_pool.rb:337:in “with_force_shutdown'

adffbed67d4224c6177f20c4e042879b | /home/foreman/vendor/ruby/2.

st.rb:75:1in “handle_request'

adffbed67d4224c6177f20c4e042879b | /home/foreman/vendor/ruby/2.

r.rb:431:in ‘process_client'

adffbed67d4224c6177£20c4e042879b | /home/foreman/vendor/ruby/2.

d_pool.rb:145:in "block in spawn_thread'

adffbed67d4224c6177£20c4e042879b | /home/foreman/vendor/ruby/2.

7.0/gems/actionpack-6.0.3.5/1ib/ac
7.0/gems/actionpack-6.0.3.5/1ib/ac
7.0/gems/rack-2.2.3/1ib/rack/metho
7.0/gems/rack-2.2.3/1ib/rack/runti
7.0/gems/activesupport—-6.0.3.5/1ib
7.0/gems/actionpack-6.0.3.5/1ib/ac
7.0/gems/actionpack-6.0.3.5/1ib/ac
7.0/gems/rack-2.2.3/1ib/rack/sendf
7.0/gems/actionpack-6.0.3.5/1ib/ac
7.0/gems/secure_headers—6.3.2/1ib/
7.0/gems/railties-6.0.3.5/1ib/rail
7.0/gems/railties-6.0.3.5/1ib/rail
7.0/gems/railties-6.0.3.5/1ib/rail
7.0/gems/rack-2.2.3/1ib/rack/urlma
7.0/gems/rack-2.2.3/1lib/rack/urlma
7.0/gems/rack-2.2.3/1ib/rack/urlma
7.0/gems/puma-5.2.2/1lib/puma/confi
7.0/gems/puma-5.2.2/1ib/puma/reque
7.0/gems/puma-5.2.2/1ib/puma/threa
7.0/gems/puma-5.2.2/1ib/puma/reque
7.0/gems/puma-5.2.2/1ib/puma/serve
7.0/gems/puma-5.2.2/1ib/puma/threa

7.0/gems/logging-2.3.0/1ib/logging

/diagnostic_context.rb:474:in “block in create_with_logging_context'
2021-04-07T13:36:26 [I|appladffbed6] Completed 500 Internal Server Error in 95ms (ActiveRecord: 56

.3ms | Allocations: 12112)
Any hints how to debug this issue?

Thank you in advance
Harm

Associated revisions

Revision e97aec2b - 04/14/2021 09:50 AM - Lukas Zapletal
Fixes #32266 - render_error call in userdata fixed (#8442)

History

#1 - 04/07/2021 01:58 PM - Harm Endres

It appears that the client IP is not being transmitted properly. When a user-data template is assigned to the smart proxy, the client gets the

configuration from the proxy itself.

2021-04-07T13:36:26 [I|applad4ffbed6] Started GET "/userdata/user-data?url=http%$3A%2F%2Fforeman-proxy.example.c
om%3A8000" for 10.0.0.1 at 2021-04-07 13:36:26 +0000
2021-04-07T13:36:26 [I|applad4ffbed6] Processing by UserdataController#userdata as TEXT

2021-04-07T13:36:26 [I|appladffbedb] Parameters:
"=>{}}

{"url"=>"http://foreman-proxy.example.com:8000", "userdatum

2021-04-07T13:36:26 [W|applad4ffbed6] wrong number of arguments (given 1, expected 2)

#2 - 04/07/2021 02:18 PM - Harm Endres

It seems the setting mentioned in this Pull Request is missing since 2.

4.0.

https://github.com/theforeman/foreman-documentation/pull/252/files#diff-79546fb76dad736e109cd704769b2dc96d084c14aa51659f1153ab773548ca

14

#3 - 04/08/2021 05:34 AM - Harm Endres

| looked in the database, the remote_addr setting seems to have been lost. Is this on purpose?

#4 - 04/08/2021 07:00 AM - Harm Endres

If I understood the "Reverse proxy handling" part correctly, this is intentional?

https://theforeman.org/manuals/2.4/index.html#Upgradewarnings

#5 - 04/08/2021 07:56 AM - Harm Endres

- Status changed from New to Rejected

Setting :trusted_proxies properly fixed the issue, sorry for the noise.

#6 - 04/13/2021 07:26 AM - Lukas Zapletal
- Status changed from Rejected to Assigned
- Assignee set to Lukas Zapletal

- Priority changed from Normal to Low

- Triaged changed from No to Yes

Hello, still it is a bug in error rendering. Easy fix. Thanks for the report.

#7 - 04/13/2021 07:28 AM - The Foreman Bot
- Status changed from Assigned to Ready For Testing
- Pull request https://github.com/theforeman/foreman/pull/8442 added

#8 - 04/14/2021 09:50 AM - The Foreman Bot
- Fixed in Releases 2.5.0 added

#9 - 04/14/2021 10:01 AM - Anonymous
- Status changed from Ready For Testing to Closed
https://github.com/theforeman/foreman-documentation/pull/252/files#diff-79546fb76dad736e109cd704769b2dc96d084c14aa51659f1153ab773548ca14
https://github.com/theforeman/foreman-documentation/pull/252/files#diff-79546fb76dad736e109cd704769b2dc96d084c14aa51659f1153ab773548ca14
https://theforeman.org/manuals/2.4/index.html#Upgradewarnings

Applied in changeset foreman|e97aec2be2fdf6b1dcbbaadbi11455b962b145f10.

#10 - 05/05/2021 12:02 PM - The Foreman Bot
- Pull request https://github.com/theforeman/foreman/pull/8504 added

#11 - 05/05/2021 02:23 PM - Tomer Brisker

- Category set to Templates

#12 - 05/05/2021 02:45 PM - Tomer Brisker
- Fixed in Releases 2.4.1 added
https://projects.theforeman.org/projects/foreman/repository/foreman/revisions/e97aec2be2fdf6b1dcbbaa9b11455b962b145f10
http://www.tcpdf.org

